<script setup lang="ts">
import { useAppStore } from '@/store/app'
import { AppError } from '@/scripts/types'
import { computed } from 'vue'
import { useRouter } from 'vue-router'

const router = useRouter()

const app = useAppStore()

function close() {
  app.globalMessageModal = false
}

const snackbarColor = computed(() => {
  switch (app.globalSnackbarType) {
    case 'error':
      return 'error'
    case 'success':
      return 'success'
    default:
      return ''
  }
})

function goVote() {
  router.push(`/votes/${app.globalNewVoteIndex}/form`)
  app.clearNewOpenVoteNotif()
}

</script>

<template>
    <div>

        <v-snackbar v-model="app.globalSnackbarDisplayed" :timeout="2000" :color="snackbarColor">
            {{ app.globalSnackbarText }}
            <template v-slot:actions>
                <v-btn variant="text" @click="app.globalSnackbarDisplayed = false">Fermer</v-btn>
            </template>
        </v-snackbar>

        <v-snackbar v-model="app.globalNewVote" :timeout="5000"  color="success" @click="goVote">
            Un nouveau vote est disponible
            <template v-slot:actions>
                <v-btn variant="tonal">Voter !</v-btn>
            </template>
        </v-snackbar>

        <v-dialog v-model="app.globalMessageModal" v-if="app.globalMessageError === AppError.TequilaError" width="600px">
            <v-card color="error">
                <v-card-title>Erreur Tequila</v-card-title>
                <v-card-text>
                    Une erreur est survenue lors de la connexion avec Tequila (EPFL).<br />
                    Merci de contacter le support.
                </v-card-text>
                <v-card-actions>
                    <v-btn link to="/help" variant="outlined" @click="close">Support</v-btn>
                    <div class="grow"></div>
                    <v-btn @click="close">Fermer</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog v-model="app.globalMessageModal" v-if="app.globalMessageError === AppError.InternalError" width="600px">
            <v-card color="error">
                <v-card-title>Erreur Interne</v-card-title>
                <v-card-text>
                    Une erreur interne est survenue lors de la dernière opération.<br />
                    Merci de contacter le support.
                </v-card-text>
                <v-card-actions>
                    <v-btn link to="/help" variant="outlined" @click="close">Support</v-btn>
                    <div class="grow"></div>
                    <v-btn @click="close">Fermer</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog v-model="app.globalMessageModal" v-if="app.globalMessageError === AppError.NetworkError" width="600px">
            <v-card>
                <v-card-title>Erreur réseau</v-card-title>
                <v-card-text>
                    Une erreur réseau est survenue lors de la dernière opération.<br />
                    Vous pouvez essayer de rafraichir la page et si le problème persiste merci de contacter le support.
                </v-card-text>
                <v-card-actions>
                    <v-btn link to="/help" variant="outlined" @click="close">Support</v-btn>
                    <div class="grow"></div>
                    <v-btn @click="close">Fermer</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog v-model="app.globalMessageModal" v-if="app.globalMessageError === AppError.QRCodeError" width="600px">
            <v-card color="warning">
                <v-card-title>Erreur scanneur de QR Code</v-card-title>
                <v-card-text>
                    Une erreur est survenue avec le scanneur de QR code.<br />
                    Vérifiez que vous avez bien donnée toutes les autorisation via votre navigateur (et parfois aussi votre OS). Si le problème persiste merci de contacter le support.
                </v-card-text>
                <v-card-actions>
                    <v-btn link to="/help" variant="outlined" @click="close">Support</v-btn>
                    <div class="grow"></div>
                    <v-btn @click="close">Fermer</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog v-model="app.globalMessageModal" v-if="app.globalMessageError === AppError.CannotBindTicket" width="600px">
            <v-card color="warning">
                <v-card-title>Ticket de présence invalide</v-card-title>
                <v-card-text>
                    <p>Plusieurs raisons sont possibles:</p>
                    <ul class="list-disc ml-3 mb-3">
                        <li>le ticket est déjà lié à quelqu'un</li>
                        <li>le ticket n'est pas activé</li>
                    </ul>
                    <p>Si le problème persiste merci de contacter le support.</p>
                </v-card-text>
                <v-card-actions>
                    <v-btn link to="/help" variant="outlined" @click="close">Support</v-btn>
                    <div class="grow"></div>
                    <v-btn @click="close">Fermer</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog v-model="app.globalMessageModal" v-if="app.globalMessageError === AppError.OperationFailed" width="600px">
            <v-card color="warning">
                <v-card-title>La dernière opération a échoué</v-card-title>
                <v-card-text>
                    Une erreur est survenue lors de la dernière opération.<br />
                    Si le problème persiste merci de contacter le support.
                </v-card-text>
                <v-card-actions>
                    <v-btn link to="/help" variant="outlined" @click="close">Support</v-btn>
                    <div class="grow"></div>
                    <v-btn @click="close">Fermer</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog v-model="app.globalMessageModal" v-if="app.globalMessageError === AppError.OpenVoteFailed" width="600px">
            <v-card color="warning">
                <v-card-title>Impossible d'ouvrir le vote</v-card-title>
                <v-card-text>
                    Impossible d'ouvrir le vote : est-ce que les scrutateurs ont bien généré une clée ?
                </v-card-text>
                <v-card-actions>
                    <div class="grow"></div>
                    <v-btn @click="close">Fermer</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </div>
</template>
